
From: Patrick Gefre <pfg@sgi.com>

Allow hardware flow control to be set from an ioctl.

Signed-off-by: Patrick Gefre <pfg@sgi.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/serial/ioc4_serial.c |   11 ++++-------
 1 files changed, 4 insertions(+), 7 deletions(-)

diff -puN drivers/serial/ioc4_serial.c~altix-ioc4-serial-set-hfc-from-ioctl drivers/serial/ioc4_serial.c
--- 25/drivers/serial/ioc4_serial.c~altix-ioc4-serial-set-hfc-from-ioctl	2005-04-26 20:16:45.174911176 -0700
+++ 25-akpm/drivers/serial/ioc4_serial.c	2005-04-26 20:16:45.181910112 -0700
@@ -1765,8 +1765,11 @@ ioc4_change_speed(struct uart_port *the_
 		the_port->ignore_status_mask &= ~N_DATA_READY;
 	}
 
-	if (cflag & CRTSCTS)
+	if (cflag & CRTSCTS) {
 		info->flags |= ASYNC_CTS_FLOW;
+		port->ip_sscr |= IOC4_SSCR_HFC_EN;
+		writel(port->ip_sscr, &port->ip_serial_regs->sscr);
+	}
 	else
 		info->flags &= ~ASYNC_CTS_FLOW;
 
@@ -1825,12 +1828,6 @@ static inline int ic4_startup_local(stru
 	/* set the speed of the serial port */
 	ioc4_change_speed(the_port, info->tty->termios, (struct termios *)0);
 
-	/* enable hardware flow control - after ioc4_change_speed because
-	 * ASYNC_CTS_FLOW is set there */
-	if (info->flags & ASYNC_CTS_FLOW) {
-		port->ip_sscr |= IOC4_SSCR_HFC_EN;
-		writel(port->ip_sscr, &port->ip_serial_regs->sscr);
-	}
 	info->flags |= UIF_INITIALIZED;
 	return 0;
 }
_
